/*
*
* Copyright (c) 2005 Sun Microsystems, Inc.
* All rights reserved.
* You may not modify, use, reproduce, or distribute this software except in compliance with the terms
* of the License at: http://developer.sun.com/berkeley_license.html
* Author : Sameer Tyagi, Sun Microsystems s.t@sun.com
* "Realizing Strategies for Document-Based Web Services With JAX-WS 2.0"
*  http://java.sun.com/developer/technicalArticles/xml/jaxrpcpatterns
*/

import javax.activation.*;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.Source;
import java.io.*;
import javax.xml.ws.BindingProvider;
import com.examples.attachmentservice.clientbindings.*;
import com.examples.types.*;
import javax.xml.ws.soap.SOAPBinding;

public class WSDLClient {
    public static void main(String[] args) {
        try {

			String url = System.getProperty("serviceurl");
           // String filename = "Uploadme.doc";
            String filename = "purchaseorder.xml";
			XMLStringService serviceproxy = new XMLStringService();
		//	IStringService stub = (IStringService) (serviceproxy.getIStringServicePort());
			Object stub =serviceproxy.getIStringServicePort();

        ((BindingProvider) stub).getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, url);
// default is 1KB if not set		
		((BindingProvider) stub).getRequestContext().put( com.sun.xml.ws.developer.JAXWSProperties.MTOM_THRESHOLOD_VALUE,0);
    //get the binding and enable mtom
            SOAPBinding binding = (SOAPBinding)((BindingProvider)stub).getBinding ();
            binding.setMTOMEnabled (true);

			IStringService stub1 = (IStringService)stub;
            sendRawBytesFromFile(filename, stub1);
     


        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

   /* private static void sendMtomFile(String filename, IStringService stub) throws Exception {

String data = new String("sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss");

MtomData mtom = new MtomData();
mtom.setData(data.getBytes());
        String response = stub.storeDocumentService(mtom);
        System.out.println("Response from server " + response);
    }*/

    public static void sendRawBytesFromFile(String filename, IStringService stub) throws Exception {
        System.out.println("========================================== sending raw byte data ========================");
     //   SayRawHello request = new SayRawHello(readStringFromFileRaw(filename).getBytes());
      //  SayRawHelloResponse response = stub.sayRawHello(request);

	    byte[] raw = stub.sayRawHello(getBytesFromFile(filename));
	
        System.out.println("Server replied back with following raw bytes : \n ");
        for (int i = 0; i < raw.length; i++) {
            System.out.print(raw[i]);
		}	

	    String answer = new String(raw);
        System.out.println("\nRaw bytes from server in string format are : \n " + answer);
        System.out.println("==================================================================");

    }


    /**
     * Reads the contents form a file and returns a String
     *
     * @param filename
     * @return
     * @throws Exception
     */
    private static String readStringFromFileRaw(String filename) throws Exception {
        StringBuffer sb = new StringBuffer();
        BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(filename)));
        String input = br.readLine();
        while (input != null) {
            sb.append(input);
            input = br.readLine();
        }
        br.close();
        String contents = sb.toString();
        return contents;
    }


	 // Returns the contents of the file in a byte array.
    public static byte[] getBytesFromFile(String filename) throws IOException {
		File file = new File(filename);
        // Get the size of the file
        long length = file.length();

// Create the byte array to hold the data
        byte[] bytes = new byte[(int)length];
        // Read in the bytes

        InputStream is = new FileInputStream(file);
    
        int offset = 0;
        int numRead = 0;
        while (offset < bytes.length
               && (numRead=is.read(bytes, offset, bytes.length-offset)) >= 0) {
            offset += numRead;
        }
    
        // Ensure all the bytes have been read in
        if (offset < bytes.length) {
            throw new IOException("Could not completely read file "+file.getName());
        }
    
        // Close the input stream and return bytes
        is.close();
        return bytes;
    }
}
